/* A Bison parser, made by GNU Bison 3.6.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.6.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "cfg_file.y"

/*  
    VTun - Virtual Tunnel over TCP/IP network.

    Copyright (C) 1998-2016  Maxim Krasnyansky <max_mk@yahoo.com>

    VTun has been derived from VPPP package by Maxim Krasnyansky. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
 */

/*
 * $Id: cfg_file.y,v 1.8.2.8 2016/10/01 21:27:51 mtbishop Exp $
 */ 

#include "config.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>

#include <syslog.h>

#include "compat.h"
#include "vtun.h"
#include "lib.h"

int lineno = 1;

struct vtun_host *parse_host;
extern struct vtun_host default_host;

llist  *parse_cmds;
struct vtun_cmd parse_cmd;

llist host_list;

int  cfg_error(const char *fmt, ...);
int  add_cmd(llist *cmds, char *prog, char *args, int flags);
void *cp_cmd(void *d, void *u);
int  free_cmd(void *d, void *u);

void copy_addr(struct vtun_host *to, struct vtun_host *from);
int  free_host(void *d, void *u);
void free_addr(struct vtun_host *h);
void free_host_list(void);

int  parse_syslog(char *facility);

int yyparse(void);
int yylex(void);	
int yyerror(char *s); 

#define YYERROR_VERBOSE 1


#line 137 "cfg_file.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_CFG_FILE_TAB_H_INCLUDED
# define YY_YY_CFG_FILE_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    K_OPTIONS = 258,               /* K_OPTIONS  */
    K_DEFAULT = 259,               /* K_DEFAULT  */
    K_PORT = 260,                  /* K_PORT  */
    K_BINDADDR = 261,              /* K_BINDADDR  */
    K_PERSIST = 262,               /* K_PERSIST  */
    K_TIMEOUT = 263,               /* K_TIMEOUT  */
    K_PASSWD = 264,                /* K_PASSWD  */
    K_PROG = 265,                  /* K_PROG  */
    K_PPP = 266,                   /* K_PPP  */
    K_SPEED = 267,                 /* K_SPEED  */
    K_IFCFG = 268,                 /* K_IFCFG  */
    K_FWALL = 269,                 /* K_FWALL  */
    K_ROUTE = 270,                 /* K_ROUTE  */
    K_DEVICE = 271,                /* K_DEVICE  */
    K_MULTI = 272,                 /* K_MULTI  */
    K_SRCADDR = 273,               /* K_SRCADDR  */
    K_IFACE = 274,                 /* K_IFACE  */
    K_ADDR = 275,                  /* K_ADDR  */
    K_TYPE = 276,                  /* K_TYPE  */
    K_PROT = 277,                  /* K_PROT  */
    K_NAT_HACK = 278,              /* K_NAT_HACK  */
    K_COMPRESS = 279,              /* K_COMPRESS  */
    K_ENCRYPT = 280,               /* K_ENCRYPT  */
    K_KALIVE = 281,                /* K_KALIVE  */
    K_STAT = 282,                  /* K_STAT  */
    K_UP = 283,                    /* K_UP  */
    K_DOWN = 284,                  /* K_DOWN  */
    K_SYSLOG = 285,                /* K_SYSLOG  */
    K_IPROUTE = 286,               /* K_IPROUTE  */
    K_HOST = 287,                  /* K_HOST  */
    K_ERROR = 288,                 /* K_ERROR  */
    WORD = 289,                    /* WORD  */
    PATH = 290,                    /* PATH  */
    STRING = 291,                  /* STRING  */
    NUM = 292,                     /* NUM  */
    DNUM = 293                     /* DNUM  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif
/* Token kinds.  */
#define YYEOF 0
#define YYerror 256
#define YYUNDEF 257
#define K_OPTIONS 258
#define K_DEFAULT 259
#define K_PORT 260
#define K_BINDADDR 261
#define K_PERSIST 262
#define K_TIMEOUT 263
#define K_PASSWD 264
#define K_PROG 265
#define K_PPP 266
#define K_SPEED 267
#define K_IFCFG 268
#define K_FWALL 269
#define K_ROUTE 270
#define K_DEVICE 271
#define K_MULTI 272
#define K_SRCADDR 273
#define K_IFACE 274
#define K_ADDR 275
#define K_TYPE 276
#define K_PROT 277
#define K_NAT_HACK 278
#define K_COMPRESS 279
#define K_ENCRYPT 280
#define K_KALIVE 281
#define K_STAT 282
#define K_UP 283
#define K_DOWN 284
#define K_SYSLOG 285
#define K_IPROUTE 286
#define K_HOST 287
#define K_ERROR 288
#define WORD 289
#define PATH 290
#define STRING 291
#define NUM 292
#define DNUM 293

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 67 "cfg_file.y"

   char *str;
   int  num;
   struct { int num1; int num2; } dnum;

#line 271 "cfg_file.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_CFG_FILE_TAB_H_INCLUDED  */
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_K_OPTIONS = 3,                  /* K_OPTIONS  */
  YYSYMBOL_K_DEFAULT = 4,                  /* K_DEFAULT  */
  YYSYMBOL_K_PORT = 5,                     /* K_PORT  */
  YYSYMBOL_K_BINDADDR = 6,                 /* K_BINDADDR  */
  YYSYMBOL_K_PERSIST = 7,                  /* K_PERSIST  */
  YYSYMBOL_K_TIMEOUT = 8,                  /* K_TIMEOUT  */
  YYSYMBOL_K_PASSWD = 9,                   /* K_PASSWD  */
  YYSYMBOL_K_PROG = 10,                    /* K_PROG  */
  YYSYMBOL_K_PPP = 11,                     /* K_PPP  */
  YYSYMBOL_K_SPEED = 12,                   /* K_SPEED  */
  YYSYMBOL_K_IFCFG = 13,                   /* K_IFCFG  */
  YYSYMBOL_K_FWALL = 14,                   /* K_FWALL  */
  YYSYMBOL_K_ROUTE = 15,                   /* K_ROUTE  */
  YYSYMBOL_K_DEVICE = 16,                  /* K_DEVICE  */
  YYSYMBOL_K_MULTI = 17,                   /* K_MULTI  */
  YYSYMBOL_K_SRCADDR = 18,                 /* K_SRCADDR  */
  YYSYMBOL_K_IFACE = 19,                   /* K_IFACE  */
  YYSYMBOL_K_ADDR = 20,                    /* K_ADDR  */
  YYSYMBOL_K_TYPE = 21,                    /* K_TYPE  */
  YYSYMBOL_K_PROT = 22,                    /* K_PROT  */
  YYSYMBOL_K_NAT_HACK = 23,                /* K_NAT_HACK  */
  YYSYMBOL_K_COMPRESS = 24,                /* K_COMPRESS  */
  YYSYMBOL_K_ENCRYPT = 25,                 /* K_ENCRYPT  */
  YYSYMBOL_K_KALIVE = 26,                  /* K_KALIVE  */
  YYSYMBOL_K_STAT = 27,                    /* K_STAT  */
  YYSYMBOL_K_UP = 28,                      /* K_UP  */
  YYSYMBOL_K_DOWN = 29,                    /* K_DOWN  */
  YYSYMBOL_K_SYSLOG = 30,                  /* K_SYSLOG  */
  YYSYMBOL_K_IPROUTE = 31,                 /* K_IPROUTE  */
  YYSYMBOL_K_HOST = 32,                    /* K_HOST  */
  YYSYMBOL_K_ERROR = 33,                   /* K_ERROR  */
  YYSYMBOL_WORD = 34,                      /* WORD  */
  YYSYMBOL_PATH = 35,                      /* PATH  */
  YYSYMBOL_STRING = 36,                    /* STRING  */
  YYSYMBOL_NUM = 37,                       /* NUM  */
  YYSYMBOL_DNUM = 38,                      /* DNUM  */
  YYSYMBOL_39_n_ = 39,                     /* '\n'  */
  YYSYMBOL_40_ = 40,                       /* '{'  */
  YYSYMBOL_41_ = 41,                       /* '}'  */
  YYSYMBOL_YYACCEPT = 42,                  /* $accept  */
  YYSYMBOL_config = 43,                    /* config  */
  YYSYMBOL_statement = 44,                 /* statement  */
  YYSYMBOL_45_1 = 45,                      /* $@1  */
  YYSYMBOL_46_2 = 46,                      /* $@2  */
  YYSYMBOL_options = 47,                   /* options  */
  YYSYMBOL_option = 48,                    /* option  */
  YYSYMBOL_bindaddr_option = 49,           /* bindaddr_option  */
  YYSYMBOL_syslog_opt = 50,                /* syslog_opt  */
  YYSYMBOL_host_options = 51,              /* host_options  */
  YYSYMBOL_host_option = 52,               /* host_option  */
  YYSYMBOL_53_3 = 53,                      /* $@3  */
  YYSYMBOL_54_4 = 54,                      /* $@4  */
  YYSYMBOL_55_5 = 55,                      /* $@5  */
  YYSYMBOL_56_6 = 56,                      /* $@6  */
  YYSYMBOL_compress = 57,                  /* compress  */
  YYSYMBOL_keepalive = 58,                 /* keepalive  */
  YYSYMBOL_srcaddr_options = 59,           /* srcaddr_options  */
  YYSYMBOL_srcaddr_option = 60,            /* srcaddr_option  */
  YYSYMBOL_command_options = 61,           /* command_options  */
  YYSYMBOL_command_option = 62,            /* command_option  */
  YYSYMBOL_63_7 = 63,                      /* $@7  */
  YYSYMBOL_prog_options = 64,              /* prog_options  */
  YYSYMBOL_prog_option = 65                /* prog_option  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_uint8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if !defined yyoverflow

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* !defined yyoverflow */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   217

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  42
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  24
/* YYNRULES -- Number of rules.  */
#define YYNRULES  88
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  142

#define YYMAXUTOK   293


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      39,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    40,     2,    41,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,    86,    86,    87,    90,    91,    93,    93,    98,    98,
     132,   139,   140,   144,   145,   150,   152,   157,   162,   167,
     172,   177,   182,   187,   192,   194,   201,   206,   211,   216,
     223,   227,   234,   241,   242,   247,   248,   253,   258,   262,
     266,   274,   283,   283,   288,   296,   296,   301,   308,   315,
     320,   325,   334,   336,   336,   341,   341,   346,   353,   360,
     365,   372,   377,   385,   391,   392,   393,   397,   403,   409,
     415,   419,   425,   426,   427,   430,   431,   431,   439,   444,
     449,   454,   459,   464,   471,   472,   476,   480,   484
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if YYDEBUG || 0
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "K_OPTIONS",
  "K_DEFAULT", "K_PORT", "K_BINDADDR", "K_PERSIST", "K_TIMEOUT",
  "K_PASSWD", "K_PROG", "K_PPP", "K_SPEED", "K_IFCFG", "K_FWALL",
  "K_ROUTE", "K_DEVICE", "K_MULTI", "K_SRCADDR", "K_IFACE", "K_ADDR",
  "K_TYPE", "K_PROT", "K_NAT_HACK", "K_COMPRESS", "K_ENCRYPT", "K_KALIVE",
  "K_STAT", "K_UP", "K_DOWN", "K_SYSLOG", "K_IPROUTE", "K_HOST", "K_ERROR",
  "WORD", "PATH", "STRING", "NUM", "DNUM", "'\\n'", "'{'", "'}'",
  "$accept", "config", "statement", "$@1", "$@2", "options", "option",
  "bindaddr_option", "syslog_opt", "host_options", "host_option", "$@3",
  "$@4", "$@5", "$@6", "compress", "keepalive", "srcaddr_options",
  "srcaddr_option", "command_options", "command_option", "$@7",
  "prog_options", "prog_option", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,    10,
     123,   125
};
#endif

#define YYPACT_NINF (-75)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -75,     0,   -75,   -29,   -75,   -75,   -75,   -75,   -75,    96,
     -26,   -19,   -11,    13,    -8,   -27,    38,    62,    63,    69,
      66,   -32,    64,   -75,   -75,     4,   -75,   116,   116,   -75,
     -13,   -75,   -75,   -75,   -75,   -75,   -75,   -75,   -75,   -75,
     -75,   -75,   -75,   -75,   -75,    75,    76,    80,    49,    82,
      81,    79,    83,    84,    85,   -75,    93,   -75,    94,   -75,
     -75,   -75,   -75,    39,   -75,    67,   -12,   102,   -75,   105,
     -75,   -75,   -75,   -75,   -75,   -75,   -75,    11,   -75,   -75,
     -75,    21,   -75,    44,   -75,   113,   114,   -75,   -75,   -75,
     -75,   -75,   -75,   -75,   121,     2,   128,   -75,     8,   -75,
     -75,   -75,   -75,   -75,   -75,   -75,   -75,   -75,   178,   178,
     -75,   -75,   -75,   -75,   -75,   -75,   -75,   127,   129,   130,
     131,   133,   -75,   -75,   137,   -75,   146,    34,   -75,   -75,
     -75,   -75,   -75,   -75,   -75,   -75,   -75,   -75,   -75,    34,
     -75,   -75
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int8 yydefact[] =
{
       2,     0,     1,     0,     6,     8,    10,     4,     3,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    25,    13,     0,    11,     0,     0,    14,
       0,    18,    19,    20,    22,    21,    16,    17,    32,    31,
      30,    24,    23,     5,    12,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    42,     0,    45,     0,    53,
      55,    57,    35,     0,    33,     0,     0,     0,    29,     0,
      48,    39,    36,    40,    41,    37,    38,    64,    49,    50,
      51,     0,    44,     0,    47,     0,     0,     7,    34,     9,
      27,    28,    26,    15,     0,     0,     0,    71,     0,    65,
      60,    58,    59,    43,    63,    61,    62,    46,    72,    72,
      70,    68,    69,    67,    52,    66,    76,     0,     0,     0,
       0,     0,    83,    75,     0,    73,     0,     0,    78,    79,
      81,    80,    82,    54,    74,    56,    86,    87,    88,    77,
      84,    85
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -75,   -75,   -75,   -75,   -75,   -75,   139,   -75,   -75,   143,
     -23,   -75,   -75,   -75,   -75,   -75,   -75,   -75,    74,    65,
     -74,   -75,   -75,    36
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     8,    10,    11,    25,    26,    69,    41,    63,
      64,    81,    83,    85,    86,   103,   107,    98,    99,   124,
     125,   127,   139,   140
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
       2,    38,    39,     3,     4,    40,    66,    67,    32,    12,
      13,     9,    14,    94,    27,    15,    94,    16,    17,    18,
      68,    28,    90,    19,    91,    20,    29,    95,    96,    31,
      95,    96,     5,     6,    21,    22,   111,    23,   112,     7,
      88,    97,    88,    24,    97,    43,    45,    46,    47,   114,
     134,    48,   134,    30,   100,    49,    50,    51,   101,   102,
      52,    53,    54,    55,    56,    57,    58,    59,    60,   136,
     137,   138,    61,    33,    45,    46,    47,   104,    62,    48,
      87,   105,   106,    49,    50,    51,    73,    74,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    34,    35,    42,
      61,    12,    13,    37,    14,    36,    62,    15,    89,    16,
      17,    18,    70,    71,    72,    19,    75,    20,    76,    77,
      78,    79,    80,    45,    46,    47,    21,    22,    48,    23,
      82,    84,    49,    50,    51,    24,    92,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    93,   116,   117,    61,
     118,   119,   120,   108,   109,    62,   116,   117,   110,   118,
     119,   120,   113,   128,    44,   129,   130,   131,   121,   132,
     122,    65,   115,     0,   126,   141,   123,   121,   133,   122,
       0,     0,     0,     0,     0,   123,     0,   135,   116,   117,
       0,   118,   119,   120,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   121,
       0,   122,     0,     0,     0,     0,     0,   123
};

static const yytype_int16 yycheck[] =
{
       0,    33,    34,     3,     4,    37,    19,    20,    35,     5,
       6,    40,     8,     5,    40,    11,     5,    13,    14,    15,
      33,    40,    34,    19,    36,    21,    37,    19,    20,    37,
      19,    20,    32,    33,    30,    31,    34,    33,    36,    39,
      63,    33,    65,    39,    33,    41,     7,     8,     9,    41,
     124,    12,   126,    40,    33,    16,    17,    18,    37,    38,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    35,
      36,    37,    33,    35,     7,     8,     9,    33,    39,    12,
      41,    37,    38,    16,    17,    18,    37,    38,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    35,    35,    35,
      33,     5,     6,    37,     8,    36,    39,    11,    41,    13,
      14,    15,    37,    37,    34,    19,    34,    21,    37,    40,
      37,    37,    37,     7,     8,     9,    30,    31,    12,    33,
      37,    37,    16,    17,    18,    39,    34,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    41,    10,    11,    33,
      13,    14,    15,    40,    40,    39,    10,    11,    37,    13,
      14,    15,    34,    36,    25,    36,    36,    36,    31,    36,
      33,    28,    98,    -1,   109,   139,    39,    31,    41,    33,
      -1,    -1,    -1,    -1,    -1,    39,    -1,    41,    10,    11,
      -1,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    31,
      -1,    33,    -1,    -1,    -1,    -1,    -1,    39
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,    43,     0,     3,     4,    32,    33,    39,    44,    40,
      45,    46,     5,     6,     8,    11,    13,    14,    15,    19,
      21,    30,    31,    33,    39,    47,    48,    40,    40,    37,
      40,    37,    35,    35,    35,    35,    36,    37,    33,    34,
      37,    50,    35,    41,    48,     7,     8,     9,    12,    16,
      17,    18,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    33,    39,    51,    52,    51,    19,    20,    33,    49,
      37,    37,    34,    37,    38,    34,    37,    40,    37,    37,
      37,    53,    37,    54,    37,    55,    56,    41,    52,    41,
      34,    36,    34,    41,     5,    19,    20,    33,    59,    60,
      33,    37,    38,    57,    33,    37,    38,    58,    40,    40,
      37,    34,    36,    34,    41,    60,    10,    11,    13,    14,
      15,    31,    33,    39,    61,    62,    61,    63,    36,    36,
      36,    36,    36,    41,    62,    41,    35,    36,    37,    64,
      65,    65
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int8 yyr1[] =
{
       0,    42,    43,    43,    44,    44,    45,    44,    46,    44,
      44,    47,    47,    48,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    48,    48,    48,    49,    49,    49,    49,
      50,    50,    50,    51,    51,    52,    52,    52,    52,    52,
      52,    52,    53,    52,    52,    54,    52,    52,    52,    52,
      52,    52,    52,    55,    52,    56,    52,    52,    57,    57,
      57,    58,    58,    58,    59,    59,    59,    60,    60,    60,
      60,    60,    61,    61,    61,    62,    63,    62,    62,    62,
      62,    62,    62,    62,    64,    64,    65,    65,    65
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     1,     4,     0,     5,     0,     5,
       1,     1,     2,     1,     2,     4,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     1,     2,     2,     2,     1,
       1,     1,     1,     1,     2,     1,     2,     2,     2,     2,
       2,     2,     0,     3,     2,     0,     3,     2,     2,     2,
       2,     2,     4,     0,     5,     0,     5,     1,     1,     1,
       1,     1,     1,     1,     0,     1,     2,     2,     2,     2,
       2,     1,     0,     1,     2,     1,     0,     3,     2,     2,
       2,     2,     2,     1,     1,     2,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
# ifndef YY_LOCATION_PRINT
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif






/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize;

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yynerrs = 0;
  yystate = 0;
  yyerrstatus = 0;

  yystacksize = YYINITDEPTH;
  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;


  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 6:
#line 93 "cfg_file.y"
                { 
		  parse_host = &default_host; 
                }
#line 1438 "cfg_file.tab.c"
    break;

  case 8:
#line 98 "cfg_file.y"
                { 
		  if( !(parse_host = malloc(sizeof(struct vtun_host))) ){
		     yyerror("No memory for the host");
		     YYABORT;
		  }

		  /* Fill new host struct with default values.
		   * MUST dup strings to be able to reread config.
		   */
	  	  memcpy(parse_host, &default_host, sizeof(struct vtun_host));
		  parse_host->host = strdup((yyvsp[0].str));
		  parse_host->passwd = NULL;
		  parse_host->sopt.host = strdup((yyvsp[0].str));

		  /* Copy local address */
		  copy_addr(parse_host, &default_host);

		  llist_copy(&default_host.up,&parse_host->up,cp_cmd,NULL);
		  llist_copy(&default_host.down,&parse_host->down,cp_cmd,NULL);

		}
#line 1464 "cfg_file.tab.c"
    break;

  case 9:
#line 120 "cfg_file.y"
                {
		  /* Check if session definition is complete */ 
		  if (!parse_host->passwd) {
		  	cfg_error("Ignored incomplete session definition '%s'", parse_host->host);
			free_host(parse_host, NULL);			
			free(parse_host);
		  } else {
		  	/* Add host to the list */
		  	llist_add(&host_list, (void *)parse_host);
		  }
		}
#line 1480 "cfg_file.tab.c"
    break;

  case 10:
#line 132 "cfg_file.y"
                {
		  cfg_error("Invalid clause '%s'",(yyvsp[0].str));
		  YYABORT;
		}
#line 1489 "cfg_file.tab.c"
    break;

  case 14:
#line 145 "cfg_file.y"
                        { 
			  if(vtun.bind_addr.port == -1)
			     vtun.bind_addr.port = (yyvsp[0].num);
			}
#line 1498 "cfg_file.tab.c"
    break;

  case 16:
#line 152 "cfg_file.y"
                        { 
			  if(vtun.svr_addr == NULL)
			    vtun.svr_addr = strdup((yyvsp[0].str));
			}
#line 1507 "cfg_file.tab.c"
    break;

  case 17:
#line 157 "cfg_file.y"
                        { 
			  if(vtun.svr_type == -1)
			     vtun.svr_type = (yyvsp[0].num);
			}
#line 1516 "cfg_file.tab.c"
    break;

  case 18:
#line 162 "cfg_file.y"
                        {  
			  if(vtun.timeout == -1)
			     vtun.timeout = (yyvsp[0].num); 	
			}
#line 1525 "cfg_file.tab.c"
    break;

  case 19:
#line 167 "cfg_file.y"
                        {
			  free(vtun.ppp);
			  vtun.ppp = strdup((yyvsp[0].str));
			}
#line 1534 "cfg_file.tab.c"
    break;

  case 20:
#line 172 "cfg_file.y"
                        {
			  free(vtun.ifcfg);
			  vtun.ifcfg = strdup((yyvsp[0].str));
			}
#line 1543 "cfg_file.tab.c"
    break;

  case 21:
#line 177 "cfg_file.y"
                        {   
			  free(vtun.route);  
			  vtun.route = strdup((yyvsp[0].str)); 	
			}
#line 1552 "cfg_file.tab.c"
    break;

  case 22:
#line 182 "cfg_file.y"
                        {   
			  free(vtun.fwall);  
			  vtun.fwall = strdup((yyvsp[0].str)); 	
			}
#line 1561 "cfg_file.tab.c"
    break;

  case 23:
#line 187 "cfg_file.y"
                        {   
			  free(vtun.iproute);  
			  vtun.iproute = strdup((yyvsp[0].str)); 	
			}
#line 1570 "cfg_file.tab.c"
    break;

  case 25:
#line 194 "cfg_file.y"
                        {
			  cfg_error("Unknown option '%s'",(yyvsp[0].str));
			  YYABORT;
			}
#line 1579 "cfg_file.tab.c"
    break;

  case 26:
#line 201 "cfg_file.y"
                        {
			  vtun.bind_addr.name = strdup((yyvsp[0].str));
			  vtun.bind_addr.type = VTUN_ADDR_NAME;
			}
#line 1588 "cfg_file.tab.c"
    break;

  case 27:
#line 206 "cfg_file.y"
                        {
			  vtun.bind_addr.name = strdup((yyvsp[0].str));
			  vtun.bind_addr.type = VTUN_ADDR_IFACE;
			}
#line 1597 "cfg_file.tab.c"
    break;

  case 28:
#line 211 "cfg_file.y"
                        {
			  vtun.bind_addr.name = strdup((yyvsp[0].str));
			  vtun.bind_addr.type = VTUN_ADDR_IFACE;
			}
#line 1606 "cfg_file.tab.c"
    break;

  case 29:
#line 216 "cfg_file.y"
                        {
			  cfg_error("Unknown option '%s'",(yyvsp[0].str));
			  YYABORT;
			}
#line 1615 "cfg_file.tab.c"
    break;

  case 30:
#line 223 "cfg_file.y"
                        {
                          vtun.syslog = (yyvsp[0].num);
  			}
#line 1623 "cfg_file.tab.c"
    break;

  case 31:
#line 227 "cfg_file.y"
                        {
                          if (parse_syslog((yyvsp[0].str))) {
                            cfg_error("Unknown syslog facility '%s'", (yyvsp[0].str));
                            YYABORT;
                          }
                        }
#line 1634 "cfg_file.tab.c"
    break;

  case 32:
#line 234 "cfg_file.y"
                        {
   			  cfg_error("Unknown syslog option '%s'",(yyvsp[0].str));
  			  YYABORT;
			}
#line 1643 "cfg_file.tab.c"
    break;

  case 36:
#line 248 "cfg_file.y"
                        {
			  free(parse_host->passwd);
			  parse_host->passwd = strdup((yyvsp[0].str));
			}
#line 1652 "cfg_file.tab.c"
    break;

  case 37:
#line 253 "cfg_file.y"
                        {
			  free(parse_host->dev);
			  parse_host->dev = strdup((yyvsp[0].str));
			}
#line 1661 "cfg_file.tab.c"
    break;

  case 38:
#line 258 "cfg_file.y"
                        { 
			  parse_host->multi = (yyvsp[0].num);
			}
#line 1669 "cfg_file.tab.c"
    break;

  case 39:
#line 262 "cfg_file.y"
                        { 
			  parse_host->timeout = (yyvsp[0].num);
			}
#line 1677 "cfg_file.tab.c"
    break;

  case 40:
#line 266 "cfg_file.y"
                        { 
			  if( (yyvsp[0].num) ){ 
			     parse_host->spd_in = parse_host->spd_out = (yyvsp[0].num);
			     parse_host->flags |= VTUN_SHAPE;
			  } else 
			     parse_host->flags &= ~VTUN_SHAPE;
			}
#line 1689 "cfg_file.tab.c"
    break;

  case 41:
#line 274 "cfg_file.y"
                        { 
			  if( yylval.dnum.num1 || yylval.dnum.num2 ){ 
			     parse_host->spd_out = yylval.dnum.num1;
		             parse_host->spd_in = yylval.dnum.num2; 	
			     parse_host->flags |= VTUN_SHAPE;
			  } else 
			     parse_host->flags &= ~VTUN_SHAPE;
			}
#line 1702 "cfg_file.tab.c"
    break;

  case 42:
#line 283 "cfg_file.y"
                        {
			  parse_host->flags &= ~(VTUN_ZLIB | VTUN_LZO); 
			}
#line 1710 "cfg_file.tab.c"
    break;

  case 44:
#line 288 "cfg_file.y"
                        {  
			  if( (yyvsp[0].num) ){
			     parse_host->flags |= VTUN_ENCRYPT;
			     parse_host->cipher = (yyvsp[0].num);
			  } else
			     parse_host->flags &= ~VTUN_ENCRYPT;
			}
#line 1722 "cfg_file.tab.c"
    break;

  case 45:
#line 296 "cfg_file.y"
                        {
			  parse_host->flags &= ~VTUN_KEEP_ALIVE; 
			}
#line 1730 "cfg_file.tab.c"
    break;

  case 47:
#line 301 "cfg_file.y"
                        {
			  if( (yyvsp[0].num) )
			     parse_host->flags |= VTUN_STAT;
			  else
			     parse_host->flags &= ~VTUN_STAT;
			}
#line 1741 "cfg_file.tab.c"
    break;

  case 48:
#line 308 "cfg_file.y"
                        { 
	      		  parse_host->persist = (yyvsp[0].num);

			  if(vtun.persist == -1) 
			     vtun.persist = (yyvsp[0].num); 	
			}
#line 1752 "cfg_file.tab.c"
    break;

  case 49:
#line 315 "cfg_file.y"
                        {  
			  parse_host->flags &= ~VTUN_TYPE_MASK;
			  parse_host->flags |= (yyvsp[0].num);
			}
#line 1761 "cfg_file.tab.c"
    break;

  case 50:
#line 320 "cfg_file.y"
                        {  
			  parse_host->flags &= ~VTUN_PROT_MASK;
			  parse_host->flags |= (yyvsp[0].num);
			}
#line 1770 "cfg_file.tab.c"
    break;

  case 51:
#line 325 "cfg_file.y"
                        {  
#ifdef ENABLE_NAT_HACK
			  parse_host->flags &= ~VTUN_NAT_HACK_MASK;
			  parse_host->flags |= (yyvsp[0].num);
#else
			  cfg_error("This vtund binary was built with the NAT hack disabled for security purposes.");
#endif
			}
#line 1783 "cfg_file.tab.c"
    break;

  case 53:
#line 336 "cfg_file.y"
                        { 
			  parse_cmds = &parse_host->up; 
   			  llist_free(parse_cmds, free_cmd, NULL);   
			}
#line 1792 "cfg_file.tab.c"
    break;

  case 55:
#line 341 "cfg_file.y"
                        { 
			  parse_cmds = &parse_host->down; 
   			  llist_free(parse_cmds, free_cmd, NULL);   
			}
#line 1801 "cfg_file.tab.c"
    break;

  case 57:
#line 346 "cfg_file.y"
                        {
			  cfg_error("Unknown option '%s'",(yyvsp[0].str));
			  YYABORT;
			}
#line 1810 "cfg_file.tab.c"
    break;

  case 58:
#line 353 "cfg_file.y"
                        { 
			  if( (yyvsp[0].num) ){  
      			     parse_host->flags |= VTUN_ZLIB; 
			     parse_host->zlevel = (yyvsp[0].num);
			  }
			}
#line 1821 "cfg_file.tab.c"
    break;

  case 59:
#line 360 "cfg_file.y"
                        {
			  parse_host->flags |= yylval.dnum.num1;
		          parse_host->zlevel = yylval.dnum.num2;
  			}
#line 1830 "cfg_file.tab.c"
    break;

  case 60:
#line 365 "cfg_file.y"
                        {
			  cfg_error("Unknown compression '%s'",(yyvsp[0].str));
			  YYABORT;
			}
#line 1839 "cfg_file.tab.c"
    break;

  case 61:
#line 372 "cfg_file.y"
                        { 
			  if( (yyvsp[0].num) )
			     parse_host->flags |= VTUN_KEEP_ALIVE;
			}
#line 1848 "cfg_file.tab.c"
    break;

  case 62:
#line 377 "cfg_file.y"
                        {
			  if( yylval.dnum.num1 ){
			     parse_host->flags |= VTUN_KEEP_ALIVE;
			     parse_host->ka_interval = yylval.dnum.num1;
		             parse_host->ka_maxfail  = yylval.dnum.num2;
			  }
  			}
#line 1860 "cfg_file.tab.c"
    break;

  case 63:
#line 385 "cfg_file.y"
                        {
			  cfg_error("Unknown keepalive option '%s'",(yyvsp[0].str));
			  YYABORT;
			}
#line 1869 "cfg_file.tab.c"
    break;

  case 67:
#line 397 "cfg_file.y"
                        {
			  free_addr(parse_host);
			  parse_host->src_addr.name = strdup((yyvsp[0].str));
			  parse_host->src_addr.type = VTUN_ADDR_NAME;
			}
#line 1879 "cfg_file.tab.c"
    break;

  case 68:
#line 403 "cfg_file.y"
                        {
			  free_addr(parse_host);
			  parse_host->src_addr.name = strdup((yyvsp[0].str));
			  parse_host->src_addr.type = VTUN_ADDR_IFACE;
			}
#line 1889 "cfg_file.tab.c"
    break;

  case 69:
#line 409 "cfg_file.y"
                        {
			  free_addr(parse_host);
			  parse_host->src_addr.name = strdup((yyvsp[0].str));
			  parse_host->src_addr.type = VTUN_ADDR_IFACE;
			}
#line 1899 "cfg_file.tab.c"
    break;

  case 70:
#line 415 "cfg_file.y"
                        {
			  parse_host->src_addr.port = (yyvsp[0].num);
			}
#line 1907 "cfg_file.tab.c"
    break;

  case 71:
#line 419 "cfg_file.y"
                        {
			  cfg_error("Unknown option '%s'",(yyvsp[0].str));
			  YYABORT;
			}
#line 1916 "cfg_file.tab.c"
    break;

  case 76:
#line 431 "cfg_file.y"
                        {
			  memset(&parse_cmd, 0, sizeof(struct vtun_cmd));
			}
#line 1924 "cfg_file.tab.c"
    break;

  case 77:
#line 434 "cfg_file.y"
                        {
			  add_cmd(parse_cmds, parse_cmd.prog, 
				  parse_cmd.args, parse_cmd.flags);
			}
#line 1933 "cfg_file.tab.c"
    break;

  case 78:
#line 439 "cfg_file.y"
                        {   
			  add_cmd(parse_cmds, strdup(vtun.ppp), strdup((yyvsp[0].str)), 
					VTUN_CMD_DELAY);
			}
#line 1942 "cfg_file.tab.c"
    break;

  case 79:
#line 444 "cfg_file.y"
                        {   
			  add_cmd(parse_cmds, strdup(vtun.ifcfg),strdup((yyvsp[0].str)),
					VTUN_CMD_WAIT);
			}
#line 1951 "cfg_file.tab.c"
    break;

  case 80:
#line 449 "cfg_file.y"
                        {   
			  add_cmd(parse_cmds, strdup(vtun.route),strdup((yyvsp[0].str)),
					VTUN_CMD_WAIT);
			}
#line 1960 "cfg_file.tab.c"
    break;

  case 81:
#line 454 "cfg_file.y"
                        {   
			  add_cmd(parse_cmds, strdup(vtun.fwall),strdup((yyvsp[0].str)),
					VTUN_CMD_WAIT);
			}
#line 1969 "cfg_file.tab.c"
    break;

  case 82:
#line 459 "cfg_file.y"
                        {   
			  add_cmd(parse_cmds, strdup(vtun.iproute),strdup((yyvsp[0].str)),
					VTUN_CMD_WAIT);
			}
#line 1978 "cfg_file.tab.c"
    break;

  case 83:
#line 464 "cfg_file.y"
                        {
			  cfg_error("Unknown cmd '%s'",(yyvsp[0].str));
			  YYABORT;
			}
#line 1987 "cfg_file.tab.c"
    break;

  case 86:
#line 476 "cfg_file.y"
                        {
			  parse_cmd.prog = strdup((yyvsp[0].str));
			}
#line 1995 "cfg_file.tab.c"
    break;

  case 87:
#line 480 "cfg_file.y"
                        {
			  parse_cmd.args = strdup((yyvsp[0].str));
			}
#line 2003 "cfg_file.tab.c"
    break;

  case 88:
#line 484 "cfg_file.y"
                        {
			  parse_cmd.flags = (yyvsp[0].num);
			}
#line 2011 "cfg_file.tab.c"
    break;


#line 2015 "cfg_file.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      yyerror (YY_("syntax error"));
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif

  return yyresult;
}

#line 488 "cfg_file.y"


int yyerror(char *s) 
{
   vtun_syslog(LOG_ERR, "%s line %d\n", s, lineno);
   return 0;
}

int cfg_error(const char *fmt, ...)
{
   char buf[255];
   va_list ap;

   /* print the argument string */
   va_start(ap, fmt);
   vsnprintf(buf,sizeof(buf),fmt,ap);
   va_end(ap);

   yyerror(buf);
   return 0;
}

int add_cmd(llist *cmds, char *prog, char *args, int flags)
{
   struct vtun_cmd *cmd;
   if( !(cmd = malloc(sizeof(struct vtun_cmd))) ){
      yyerror("No memory for the command");
      return -1;
   }
   memset(cmd, 0, sizeof(struct vtun_cmd)); 		   			

   cmd->prog = prog;
   cmd->args = args;
   cmd->flags = flags;
   llist_add(cmds, cmd);

   return 0;
}		

void *cp_cmd(void *d, void *u)
{
   struct vtun_cmd *cmd = d, *cmd_copy; 

   if( !(cmd_copy = malloc(sizeof(struct vtun_cmd))) ){
      yyerror("No memory to copy the command");
      return NULL;
   }
 
   cmd_copy->prog = strdup(cmd->prog);
   cmd_copy->args = strdup(cmd->args);
   cmd_copy->flags = cmd->flags;
   return cmd_copy;
}

int free_cmd(void *d, void *u)
{
   struct vtun_cmd *cmd = d; 
   free(cmd->prog);
   free(cmd->args);
   free(cmd);
   return 0;
}

void copy_addr(struct vtun_host *to, struct vtun_host *from)
{  
   if( from->src_addr.type ){
      to->src_addr.type = from->src_addr.type;
      to->src_addr.name = strdup(from->src_addr.name);
   }
   to->src_addr.port = from->src_addr.port;
}

void free_addr(struct vtun_host *h)
{  
   if( h->src_addr.type ){
      h->src_addr.type = 0;
      free(h->src_addr.name);
   }
}

int free_host(void *d, void *u)
{
   struct vtun_host *h = d;

   if (u && !strcmp(h->host, u))
      return 1;

   free(h->host);   
   free(h->passwd);   
   
   llist_free(&h->up, free_cmd, NULL);   
   llist_free(&h->down, free_cmd, NULL);

   free_addr(h);

   /* releases only host struct instances which were
    * allocated in the case of K_HOST except default_host */
   if( h->passwd )
      free(h);

 
   return 0;   
}

/* Find host in the hosts list.
 * NOTE: This function can be called only once since it deallocates hosts list.
 */ 
inline struct vtun_host* find_host(char *host)
{
   return (struct vtun_host *)llist_free(&host_list, free_host, host);
}

int clear_nat_hack_server(void *d, void *u)
{
	((struct vtun_host*)d)->flags &= ~VTUN_NAT_HACK_CLIENT;
	return 0;
}

int clear_nat_hack_client(void *d, void *u)
{
	((struct vtun_host*)d)->flags &= ~VTUN_NAT_HACK_SERVER;
	return 0;
}

/* Clear the VTUN_NAT_HACK flag which are not relevant to the current operation mode */
inline void clear_nat_hack_flags(int svr)
{
	if (svr)
		llist_trav(&host_list,clear_nat_hack_server,NULL);
	else 
		llist_trav(&host_list,clear_nat_hack_client,NULL);
}

inline void free_host_list(void)
{
   llist_free(&host_list, free_host, NULL);
}

static struct {
   char *c_name;
   int  c_val;
} syslog_names[] = {
    { "auth",   LOG_AUTH },
    { "cron",   LOG_CRON },
    { "daemon", LOG_DAEMON },
    { "kern",   LOG_KERN },
    { "lpr",    LOG_LPR },
    { "mail",   LOG_MAIL },
    { "news",   LOG_NEWS },
    { "syslog", LOG_SYSLOG },
    { "user",   LOG_USER },
    { "uucp",   LOG_UUCP },
    { "local0", LOG_LOCAL0 },
    { "local1", LOG_LOCAL1 },
    { "local2", LOG_LOCAL2 },
    { "local3", LOG_LOCAL3 },
    { "local4", LOG_LOCAL4 },
    { "local5", LOG_LOCAL5 },
    { "local6", LOG_LOCAL6 },
    { "local7", LOG_LOCAL7 },
    { NULL, -1 }
};

int parse_syslog(char *facility)
{
   int i;

   for (i=0; syslog_names[i].c_name;i++) {
      if (!strcmp(syslog_names[i].c_name, facility)) {
         vtun.syslog = syslog_names[i].c_val;
         return(0);
      }
   }
   return -1;
}

/* 
 * Read config file. 
 */ 
int read_config(char *file) 
{
   static int cfg_loaded = 0;
   extern FILE *yyin;

   if( cfg_loaded ){
      free_host_list();
      vtun_syslog(LOG_INFO,"Reloading configuration file");
   }	 
   cfg_loaded = 1;

   llist_init(&host_list);

   if( !(yyin = fopen(file,"r")) ){
      vtun_syslog(LOG_ERR,"Can not open %s", file);
      return -1;      
   }

   yyparse();

   free_host(&default_host, NULL);

   fclose(yyin);
  
   return !llist_empty(&host_list);     
}
